/* IN55 - TP2 - Exo 2 */
/* Ajout d'un Z-buffer */

#include <GL/glut.h>

/* Dfinitions */
void Reshape(int w,int h);
void Draw();

/* Fonction main */

int main( int argc, char **argv)
{
	//initialisation de Glut
	glutInit(&argc, argv);
	// Mode d'affichage
	glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
	// Taille et position de la fentre
	glutInitWindowSize(640,480);
	glutInitWindowPosition(200,200);  
	// Cration de la fentre
	glutCreateWindow("IN55 TP2 - Introduction  OpenGL - Exo 2");
	// Couleur d'effacement du buffer
	glClearColor(0.,0.,0.,1.);
	// Fonction pour l'affichage
	glutDisplayFunc(Draw);
	// Fonction pour le redimentionnement
	glutReshapeFunc(Reshape);
	// Boucle de gestion des vnements
	glutMainLoop();
	
	return 0;
}

/* Affichage de la scne OpenGL */
void Draw()
{ 
	// Vide le buffer de couleur et le Z-buffer
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity();

	// Dfinition du point de vue
	gluLookAt(
		2.0, 2.0,-5.0, 	// Vue lgrement sur le ct
		0.0, 0.0, 0.0, 	// On regarde le centre...
		0.0, 1.0, 0.0);	// ...verticalement

	// Axes x, y et z
	glColor3d(1.0,1.0,1.0);
	glBegin(GL_LINES);
		glVertex3f(-10.0f,0.0f,0.0f); // dbut de x
		glVertex3f( 10.0f,0.0f,0.0f); // fin  de x
		glVertex3f(0.0f,-10.0f,0.0f); // dbut de y
		glVertex3f(0.0f, 10.0f,0.0f); // fin de y
		glVertex3f(0.0f,0.0f,-10.0f); // dbut de z
		glVertex3f(0.0f,0.0f, 10.0f); // fin de z
	glEnd();

	// On dessine un cube, avec une couleur pour chaque face
	glBegin(GL_QUADS);				// dbut du carr
		glColor3d(1.,0.,0.);			// rouge
		glVertex3f( 1.0f, 1.0f, 1.0f);	// haut-gauche
		glVertex3f( 1.0f, 1.0f,-1.0f);	// haut-droit
		glVertex3f( 1.0f,-1.0f,-1.0f);	// bas-droit
		glVertex3f( 1.0f,-1.0f, 1.0f);	// bas-gauche	
		glColor3d(0.,1.,0.);			// vert
		glVertex3f(-1.0f, 1.0f, 1.0f);	// haut-gauche
		glVertex3f( 1.0f, 1.0f, 1.0f);	// haut-droit
		glVertex3f( 1.0f,-1.0f, 1.0f);	// bas-droit
		glVertex3f(-1.0f,-1.0f, 1.0f);	// bas-gauche	
		glColor3d(0.,0.,1.);			// bleu
		glVertex3f(-1.0f, 1.0f,-1.0f);	// haut-gauche
		glVertex3f(-1.0f, 1.0f, 1.0f);	// haut-droit
		glVertex3f(-1.0f,-1.0f, 1.0f);	// bas-droit
		glVertex3f(-1.0f,-1.0f,-1.0f);	// bas-gauche	
		glColor3d(1.,1.,0.);			// magenta
		glVertex3f( 1.0f, 1.0f,-1.0f);	// haut-gauche
		glVertex3f(-1.0f, 1.0f,-1.0f);	// haut-droit
		glVertex3f(-1.0f,-1.0f,-1.0f);	// bas-droit
		glVertex3f( 1.0f,-1.0f,-1.0f);	// bas-gauche	
		glColor3d(0.,1.,1.);			// cyan
		glVertex3f(-1.0f, 1.0f,-1.0f);	// haut-gauche
		glVertex3f( 1.0f, 1.0f,-1.0f);	// haut-droit
		glVertex3f( 1.0f, 1.0f, 1.0f);	// bas-droit
		glVertex3f(-1.0f, 1.0f, 1.0f);	// bas-gauche	
		glColor3d(1.,0.,1.);			// jaune
		glVertex3f(-1.0f,-1.0f, 1.0f);	// haut-gauche
		glVertex3f( 1.0f,-1.0f,1.0f);	// haut-droit
		glVertex3f( 1.0f,-1.0f,-1.0f);	// bas-droit
		glVertex3f(-1.0f,-1.0f,-1.0f);	// bas-gauche	
	glEnd();						// fin du carr

	glutSwapBuffers(); // Intervertit les deux tampons

	glutPostRedisplay();	// Demande de redessiner la scene
}

/* Redimentionnement */
void Reshape(int w, int h) 
{
	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity();
	glViewport(0,0,w,h);
	glClearDepth(1.0);
	glEnable(GL_DEPTH_TEST);
	//glDepthFunc(GL_LEQUAL);
	glMatrixMode(GL_PROJECTION); // On slectionne la matrice de 
								// projection
	glLoadIdentity();			// On initialise la matrice
	gluPerspective(45,(float) w/h,1.,500.);	// On rgle la perspective
}
