/* IN55 - TP2 - Exo 7 */
/* Textures */

#include <GL/glut.h>
#include <math.h>

#include <iostream>

#define TITRE		"IN55 TP2 - Introduction  OpenGL - Exo 7"

#define LISTE_AXE	1
#define LISTE_CUBE	2

/* Dfinitions */
void Console();
void BuildCube(GLdouble,GLuint);
void BuildAxis(GLdouble,GLuint);
void Reshape(int,int);
void Draw();
void Special(int,int,int);
void Keyboard(unsigned char,int,int);
void Mouse(int,int,int,int);
void Motion(int,int);

/* Variables statiques */
static GLuint 	cpt = 0;
static GLint 	oldx = 320, oldy = 240;
static GLfloat	cubepx = 0.0, cubepy = 0.0, cubepz = 0.0, cuberot = 0.0,
				px = 0.0, py = 0.0, pz = 5.0,
				phi = 0, theta = 0;
static GLfloat	materiau[4] = {1.0, 0.5, 0.8, 1.0};
static GLubyte 	texture[16] = {0,0,0,0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0,0,0,0};

/* Fonction main */

int main( int argc, char **argv)
{
	// Aide
	Console();
	
	//initialisation de Glut
	glutInit(&argc, argv);
	// Mode d'affichage
	glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
	// Taille et position de la fentre
	glutInitWindowSize(640,480);
	glutInitWindowPosition(200,200);  
	// Cration de la fentre
	glutCreateWindow(TITRE);
	// Couleur d'effacement du buffer
	glClearColor(0.,0.,0.,1.);
	// Test de profondeur
	glEnable(GL_DEPTH_TEST);
	// Calculs d'clairage et matriau global
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,materiau);
	// Texture
	glEnable(GL_TEXTURE_2D);
	GLuint name;
	glGenTextures(1,&name);
	glBindTexture(GL_TEXTURE_2D,name);
	glTexImage2D(
		GL_TEXTURE_2D,	 	// type
		0,					// Mipmap : aucun
		4,					// Couleurs : 4
		2,					// Largeur : 2
		2,					// Hauteur : 2
		0,					// Largeur du bord : 0
		GL_RGBA,			// Format RGBA
		GL_UNSIGNED_BYTE,	// Type des couleurs
		texture				// Adresse de l'image
	);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	// Smooth Shading
	glShadeModel(GL_SMOOTH);
	// Perspective point de fuite
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	// Listes d'affichage : axes et cube
	glGenLists(2);
	BuildAxis(10.0, LISTE_AXE);
	BuildCube(0.5, LISTE_CUBE);
	// Fonction pour l'affichage
	glutDisplayFunc(Draw);
	// Fonction pour le redimentionnement
	glutReshapeFunc(Reshape);
	// Fonction pour les touches spciales (directionnelles, etc.)
	glutSpecialFunc(Special);
	// Fonction pour les touches alphanumriques du clavier
	glutKeyboardFunc(Keyboard);
	// Fonction pour les boutons de la souris
	glutMouseFunc(Mouse);
	// Fonction pour les mouvements de la souris
	glutPassiveMotionFunc(Motion);
	// Boucle de gestion des vnements
	glutMainLoop();
	
	return 0;
}

void Console()
{
	std::cout << TITRE 								<< std::endl << std::endl;

	std::cout << "CONTRLE POINT DE VUE"			<< std::endl;
	std::cout << "---------------------"			<< std::endl;
	std::cout << "Rotation : souris" 				<< std::endl;
	std::cout << "Se dplacer : Z,Q,S,D" 			<< std::endl;
	std::cout << "Monter/descendre : +,-" 			<< std::endl << std::endl;

	std::cout << "CONTRLE CUBE"					<< std::endl;
	std::cout << "---------------------"			<< std::endl;
	std::cout << "Tourner : home,end"				<< std::endl;
	std::cout << "Dplacer : flches dir."		 	<< std::endl;
	std::cout << "Monter/descendre : pgup,pgdown" 	<< std::endl << std::endl;

	std::cout << "VRAC"								<< std::endl;
	std::cout << "---------------------"			<< std::endl;
	std::cout << "Lumires : l"						<< std::endl;
	std::cout << "Textures : t"					 	<< std::endl;
}

/* Cre une Build List de 3 axes de longueur donne */
void BuildAxis(GLdouble length, GLuint genList)
{
	//GLuint list = glGenLists(1);
	length = length/2;
	glNewList(genList,GL_COMPILE);
		glBegin(GL_LINES);
			glColor3d(1.0,1.0,1.0);
			glVertex3f(-length,0.0f,0.0f); // dbut de x
			glVertex3f( length,0.0f,0.0f); // fin  de x
			glVertex3f(0.0f,-length,0.0f); // dbut de y
			glVertex3f(0.0f, length,0.0f); // fin de y
			glVertex3f(0.0f,0.0f,-length); // dbut de z
			glVertex3f(0.0f,0.0f, length); // fin de z
		glEnd();
	glEndList();
}

/* Cre un cube de ct entier spcifi 
 * Retourne un pointeur sur une Build List */
void BuildCube(GLdouble side, GLuint genList)
{
	//GLuint list = glGenLists(1);
	side = side/2;
	glNewList(genList,GL_COMPILE);
		glBegin(GL_QUADS);				// dbut du carr
			glTexCoord2i(0,0);
			glVertex3f(+side,+side,+side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(+side,+side,-side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(+side,-side,-side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(+side,-side,+side);	// bas-gauche	
			glTexCoord2i(0,0);
			glVertex3f(-side,+side,+side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(+side,+side,+side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(+side,-side,+side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(-side,-side,+side);	// bas-gauche	
			glTexCoord2i(0,0);
			glVertex3f(-side,+side,-side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(-side,+side,+side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(-side,-side,+side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(-side,-side,-side);	// bas-gauche	
			glTexCoord2i(0,0);
			glVertex3f(+side,+side,-side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(-side,+side,-side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(-side,-side,-side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(+side,-side,-side);	// bas-gauche	
			glTexCoord2i(0,0);
			glVertex3f(-side,+side,-side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(+side,+side,-side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(+side,+side,+side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(-side,+side,+side);	// bas-gauche	
			glTexCoord2i(0,0);
			glVertex3f(-side,-side,+side);	// haut-gauche
			glTexCoord2i(0,1);
			glVertex3f(+side,-side,+side);	// haut-droit
			glTexCoord2i(1,1);
			glVertex3f(+side,-side,-side);	// bas-droit
			glTexCoord2i(1,0);
			glVertex3f(-side,-side,-side);	// bas-gauche	
		glEnd();						// fin du cube
	glEndList();
}

/* Affichage de la scne OpenGL */
void Draw()
{
	// Vide le buffer de couleur et le Z-buffer
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity();

	// Transformations de visualisation
	glRotated(phi,1.0,0.0,0.0);
	glRotated(theta,0.0,1.0,0.0);
	glTranslated(-px,-py,-pz);

	// Sauvegarde de la matrice actuelle
	glPushMatrix();

	if (glIsEnabled(GL_LIGHT0))
	{
		// Lumire
		glRotated(0.02*cpt,-0.5,0.0,0.5);
		glTranslated(0.0,1.5,0.0);
		GLfloat poslum[4] = {0.0, 0.0, 0.0, 1.0};
		glLightfv(GL_LIGHT0, GL_POSITION, poslum);
	
		// On ressort la matrice de la pile, on re-sauve
		glPopMatrix();
		glPushMatrix();
	}
	
	// Axes
	glCallList(LISTE_AXE);
	
	// Cube  l'origine, tourne sur lui-mme
	glTranslated(cubepx,cubepy,cubepz);
	glRotated(cuberot,0.0,1.0,0.0);
	glCallList(LISTE_CUBE);

	// On ressort la matrice de la pile, on re-sauve
	glPopMatrix();
	glPushMatrix();
	
	// Cube dcal sur x, tourne sur lui-mme
	glTranslated(2.0,0.0,0.0);
	glRotated(.04*cpt,0.0,1.0,0.0);
	glCallList(LISTE_CUBE);

	// Encore une fois
	glPopMatrix();

	// Cube tournant autour de l'origine, tourne sur lui-mme
	glRotated(.03*cpt,-0.5,0.0,0.5);
	glTranslated(0.0,1.5,0.0);
	glRotated(.01*cpt,1.0,0.0,0.0);
	glRotated(.02*cpt,0.0,1.0,0.0);
	glRotated(.03*cpt,0.0,0.0,1.0);
	glCallList(LISTE_CUBE);

	glutSwapBuffers(); // Intervertit les deux tampons

	glutPostRedisplay();	// Demande de redessiner la scene

	cpt++;
}

/* Redimensionnement */
void Reshape(int w, int h) 
{
	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity();
	glViewport(0,0,w,h);
	glClearDepth(1.0);
	glMatrixMode(GL_PROJECTION); // On slectionne la matrice de 
								// projection
	glLoadIdentity();			// On initialise la matrice
	gluPerspective(45,(float) w/h,1.,500.);	// On rgle la perspective
}

/* Ecouteur des touches spciales du clavier */
/* On agit sur le cube  l'origine */
void Special(int touche,int x,int y)
{
	switch(touche)
	{
		case GLUT_KEY_LEFT:		// +x
		cubepx-=0.1;
		break;
		case GLUT_KEY_RIGHT:	// -x
		cubepx+=0.1;
		break;
		case GLUT_KEY_UP:		// +z
		cubepz-=0.1;
		break;
		case GLUT_KEY_DOWN:		// -z
		cubepz+=0.1;
		break;
		case GLUT_KEY_PAGE_UP:	// +y
		cubepy+=0.1;
		break;
		case GLUT_KEY_PAGE_DOWN:// -y
		cubepy-=0.1;
		break;
		case GLUT_KEY_HOME:		// +rot
		cuberot+=5.;
		break; 
		case GLUT_KEY_END:		// -rot
		cuberot-=5.;
		break; 
	}
}

/* Ecouteur des touches alphanumriques du clavier */
/* On agit sur le point de vue */
void Keyboard(unsigned char touche,int x,int y)
{
	switch(touche)
	{
		case 'z': // pas en avant
		px+=0.3*sin(theta/360.0*6.283185);
		pz-=0.3*cos(theta/360.0*6.283185);
		break;
		case 's': // pas en arrire
		px-=0.3*sin(theta/360.0*6.283185);
		pz+=0.3*cos(theta/360.0*6.283185);
		break;
		case 'q': // pas  gauche
		px-=0.3*cos(theta/360.0*6.283185);
		pz-=0.3*sin(theta/360.0*6.283185);
		break;
		case 'd': // pas  droite
		px+=0.3*cos(theta/360.0*6.283185);
		pz+=0.3*sin(theta/360.0*6.283185);
		break;
		case '+' : // vers le haut
		py += 0.3;
		break;
		case '-' : // vers le bas
		py -= 0.3;
		break;
		case 'l' : // lumire
		if (glIsEnabled(GL_LIGHT0))
			glDisable(GL_LIGHT0);
		else
			glEnable(GL_LIGHT0);
		break;
		case 't' : // texture
		if (glIsEnabled(GL_TEXTURE_2D))
			glDisable(GL_TEXTURE_2D);
		else
			glEnable(GL_TEXTURE_2D);
		break;
	}
}

/* Ecouteur des boutons de la souris */
void Mouse(int bouton,int etat,int x,int y)
{
}

/* Ecouteur des mouvements de la souris */
void Motion(int x,int y)
{
	phi+=90.0*(y-oldy)/320;
	theta+=90.0*(x-oldx)/320;
	//if (phi>=360) phi-=360;
	//if (phi<0) phi=360+phi;
	if (theta>=360) theta-=360;
	if (theta<0) theta=360+theta;
    oldx=x;
	oldy=y;
}
